Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3483)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3484)
@@ -5370,4 +5726,18 @@
       INTEGER(iwp), DIMENSION(1:2,nxl:nxr), INTENT(IN)         ::  logc_kbounds  !< 
 
+      INTEGER(iwp) :: kct
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+
+      INTEGER(iwp) ::  nzt_topo_nestbc   !<
+
       CHARACTER(LEN=1), INTENT(IN) ::  edge   !<
       CHARACTER(LEN=1), INTENT(IN) ::  var    !<
@@ -5377,10 +5747,12 @@
       INTEGER(iwp) ::  icorr   !<
       INTEGER(iwp) ::  ico     !<
+      INTEGER(iwp) ::  ijk     !<
       INTEGER(iwp) ::  i1      !<
       INTEGER(iwp) ::  j       !<
+      INTEGER(iwp) ::  ja      !<
       INTEGER(iwp) ::  jb      !<
       INTEGER(iwp) ::  jbgp    !<
       INTEGER(iwp) ::  k       !<
-      INTEGER(iwp) ::  k_wall   !< vertical index of topography top
+      INTEGER(iwp) ::  k_wall  !< vertical index of topography top
       INTEGER(iwp) ::  kcorr   !<
       INTEGER(iwp) ::  kco     !<
@@ -5389,5 +5761,8 @@
       INTEGER(iwp) ::  m       !<
       INTEGER(iwp) ::  n       !<
-                            
+      INTEGER(iwp) ::  var_flag !<
+
+      REAL(wp) ::  cellsum     !<
+      REAL(wp) ::  cellsumd    !<
       REAL(wp) ::  fk          !<
       REAL(wp) ::  fkj         !<
@@ -5396,4 +5771,6 @@
       REAL(wp) ::  fkpjp       !<
       REAL(wp) ::  fkp         !<
+      REAL(wp) ::  rcorr       !< 
+      REAL(wp) ::  rcorr_ijk   !< 
       
 !
@@ -5414,10 +5791,20 @@
       ENDIF
 
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+
       DO  i = nxl, nxr+1
 !
 !--      Determine vertical index of topography top at grid point (j,i)
-         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
-
-         DO  k = k_wall, nzt+1
+!AH         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
+
+         DO  k = nzb, nzt+1 !AH k_wall, nzt+1
             l = ic(i)
             m = jc(j)
@@ -5450,5 +5837,5 @@
                DO  kcorr = 0, ncorr-1
                   kco = k + kcorr
-                  f(kco,j,i) = logc_ratio(1,kcorr,k,i) * f(k1,j,i)
+!AH                  f(kco,j,i) = logc_ratio(1,kcorr,k,i) * f(k1,j,i)
                ENDDO
             ENDIF
@@ -5477,5 +5864,5 @@
                         ico = i + iinc * icorr
                         IF ( ico >= nxl .AND. ico <= nxr )  THEN
-                           f(k,j,ico) = logc_ratio(2,icorr,k,i) * f(k,j,i1)
+!AH                           f(k,j,ico) = logc_ratio(2,icorr,k,i) * f(k,j,i1)
                         ENDIF
                      ENDDO
@@ -5498,8 +5885,8 @@
                         DO  kcorr = 0, ncorr-1
                            kco = k + kcorr
-                           f(kco,j,ico) = 0.5_wp * ( logc_ratio(1,kcorr,k,i) * &
-                                                     f(k1,j,i)                 &
-                                                   + logc_ratio(2,icorr,k,i) * &
-                                                     f(k,j,i1) )
+!AH                           f(kco,j,ico) = 0.5_wp * ( logc_ratio(1,kcorr,k,i) * &
+!AH                                                     f(k1,j,i)                 &
+!AH                                                   + logc_ratio(2,icorr,k,i) * &
+!AH                                                     f(k,j,i1) )
                         ENDDO
                      ENDIF
@@ -5511,29 +5898,67 @@
       ENDIF  ! ( topography /= 'flat' )
 !
-!--   Rescale if f is the TKE.
-      IF ( var == 'e')  THEN
-         IF ( edge == 's' )  THEN
-            DO  i = nxl, nxr + 1
-!
-!--            Determine vertical index of topography top at grid point (j,i)
-               k_wall = get_topography_top_index_ji( j, i, 's' )
-               DO  k = k_wall, nzt+1
-                  f(k,j,i) = tkefactor_s(k,i) * f(k,j,i)
+!--   Apply the reversibility correction to the boundary-normal velocity-
+!--   component v and the scalars. It must not be applied to the boundary-
+!--   tangential velocity components u and w because their 2-D anterpolation 
+!--   cells do not cover all the child-grid nodes on the boundary.
+      IF ( .NOT. ( ( var == 'u' ) .OR. ( var == 'w' ) ) )  THEN
+         m = jc(j)
+         DO  l = icl, icr
+            DO  n = 0, kct+1
+               ijk = 1
+               cellsum   = 0.0_wp 
+               cellsumd  = 0.0_wp
+               DO  i = ifl(l), ifu(l)
+                  DO  ja = jfl(m), jfu(m)
+                     DO  k = kfl(n), kfu(n)
+                        cellsum = cellsum + MERGE( f(k,ja,i), 0.0_wp,           &
+                             BTEST( wall_flags_0(k,ja,i), var_flag ) )                        
+                        celltmpd(ijk) = ABS( fc(n,m,l) - f(k,ja,i) )
+                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
+                             0.0_wp, BTEST( wall_flags_0(k,ja,i), var_flag ) )
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
                ENDDO
-            ENDDO
-         ELSEIF ( edge == 'n' )  THEN
-            DO  i = nxl, nxr + 1
-!
-!--            Determine vertical index of topography top at grid point (j,i)
-               k_wall = get_topography_top_index_ji( j, i, 's' )
-               DO  k = k_wall, nzt+1
-                  f(k,j,i) = tkefactor_n(k,i) * f(k,j,i)
+
+               IF ( ijkfc(n,m,l) /= 0 )  THEN
+                  cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+                  rcorr     = fc(n,m,l) - cellsum
+                  cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+               ELSE
+                  cellsum   = 0.0_wp                  
+                  rcorr     = 0.0_wp
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+! 
+!--            Distribute the correction term to the child nodes according to 
+!--            their relative difference to the parent value such that the
+!--            node with the largest difference gets the largest share of the 
+!--            correction. The distribution is skipped if rcorr is negligibly 
+!--            small in order to avoid division by zero. 
+               IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+            
+               ijk = 1           
+               DO  i = ifl(l), ifu(l)
+                  DO  ja = jfl(m), jfu(m)
+                     DO  k = kfl(n), kfu(n)
+                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+                        f(k,ja,i) = f(k,ja,i) + rcorr_ijk
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
                ENDDO
-            ENDDO
-         ENDIF
-      ENDIF
+               
+            ENDDO  ! n
+         ENDDO  ! l 
+
+      ENDIF  ! var not u or w
 !
 !--   Store the boundary values also into the other redundant ghost node layers.
-!--   Please note, in case of only one ghost node layer, e.g. for the PW 
+!--   Note that in case of only one ghost node layer, e.g. for the PW 
 !--   scheme, the following loops will not be entered.
       IF ( edge == 's' )  THEN
@@ -5551,6 +5976,7 @@
  
 
-   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
-                                  r2z, var )
+   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,       &
+                                  r1z, r2z, kct, ifl, ifu, jfl, jfu, kfl, kfu, &
+                                  ijkfc, var )
 
 !
@@ -5576,4 +6002,16 @@
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN) ::  kc    !<
       
+      INTEGER(iwp) :: kct
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+
       CHARACTER(LEN=1), INTENT(IN) :: var   !<
 
@@ -5581,12 +6019,17 @@
       INTEGER(iwp) ::  ib  !<
       INTEGER(iwp) ::  ie  !<
+      INTEGER(iwp) ::  ijk !<
       INTEGER(iwp) ::  j   !<
-      INTEGER(iwp) ::  jb   !<
-      INTEGER(iwp) ::  je   !<      
+      INTEGER(iwp) ::  jb  !<
+      INTEGER(iwp) ::  je  !<      
       INTEGER(iwp) ::  k   !<
+      INTEGER(iwp) ::  ka  !<
       INTEGER(iwp) ::  l   !<
       INTEGER(iwp) ::  m   !<
       INTEGER(iwp) ::  n   !<
+      INTEGER(iwp) ::  var_flag  !<
       
+      REAL(wp) ::  cellsum     !<
+      REAL(wp) ::  cellsumd    !<
       REAL(wp) ::  fk          !<
       REAL(wp) ::  fkj         !<
@@ -5595,6 +6038,8 @@
       REAL(wp) ::  fkpjp       !<
       REAL(wp) ::  fkp         !<
-
-      
+      REAL(wp) ::  rcorr       !<
+      REAL(wp) ::  rcorr_ijk   !<
+
+
       IF ( var == 'w' )  THEN
          k  = nzt
@@ -5610,12 +6055,13 @@
       jb = nys-1
       je = nyn+1
-!
-!--   The exceedings must not be made past the outer edges in 
-!--   case of pure vertical nesting.
-      IF ( nesting_mode == 'vertical' )  THEN
-         IF ( nxl == 0  )  ib = nxl
-         IF ( nxr == nx )  ie = nxr
-         IF ( nys == 0  )  jb = nys
-         IF ( nyn == ny )  je = nyn
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
       ENDIF
          
@@ -5635,18 +6081,68 @@
       ENDDO
 !
-!--   Just fill up the second ghost-node layer for w.
+!--   Apply the reversibility correction to the boundary-normal velocity-
+!--   component w and scalars. It must not be applied to the boundary-
+!--   tangential velocity components u and v because their 2-D anterpolation 
+!--   cells do not cover all the child-grid nodes on the boundary.
+      IF ( .NOT. ( ( var == 'u' ) .OR. ( var == 'v' ) ) )  THEN  
+         IF ( var == 'w' )  THEN
+            n = kc(k)
+         ELSE
+            n = kc(k) + 1
+         ENDIF
+
+         DO  l = icl, icr
+            DO  m = jcs, jcn
+               ijk = 1
+               cellsum   = 0.0_wp
+               cellsumd  = 0.0_wp
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     DO  ka = kfl(n), kfu(n)
+                        cellsum = cellsum + MERGE( f(ka,j,i), 0.0_wp,           &
+                             BTEST( wall_flags_0(ka,j,i), var_flag ) )
+                        celltmpd(ijk) = ABS( fc(n,m,l) - f(ka,j,i) )
+                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
+                             0.0_wp, BTEST( wall_flags_0(ka,j,i), var_flag ) )                     
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
+               ENDDO
+
+               IF ( ijkfc(n,m,l) /= 0 )  THEN
+                  cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+                  rcorr     = fc(n,m,l) - cellsum
+                  cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+               ELSE
+                  cellsum   = 0.0_wp
+                  rcorr     = 0.0_wp
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+
+               IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+
+               ijk = 1
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     DO  ka = kfl(n), kfu(n)
+                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+                        f(ka,j,i) = f(ka,j,i) + rcorr_ijk
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
+               ENDDO
+               
+            ENDDO  ! m
+         ENDDO  ! l
+
+      ENDIF  ! var not u or v
+!
+!--   Just fill up the redundant second ghost-node layer for w.
       IF ( var == 'w' )  THEN
          f(nzt+1,:,:) = f(nzt,:,:)
-      ENDIF
-!
-!--   Rescale if f is the TKE.
-!--   It is assumed that the bottom surface never reaches the top boundary of a
-!--   nest domain.
-      IF ( var == 'e' )  THEN
-         DO  i = nxl, nxr
-            DO  j = nys, nyn
-               f(k,j,i) = tkefactor_t(j,i) * f(k,j,i)
-            ENDDO
-         ENDDO
       ENDIF
 
@@ -5667,15 +6163,18 @@
        CHARACTER(LEN=*), INTENT(IN) ::  var   !< identifyer for treated variable
 
+!AH       INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+
        INTEGER(iwp) ::  i         !< Running index x-direction - fine-grid
+       INTEGER(iwp) ::  icla      !< Left boundary index for anterpolation along x
+       INTEGER(iwp) ::  icra      !< Right boundary index for anterpolation along x
        INTEGER(iwp) ::  ii        !< Running index x-direction - coarse grid
-       INTEGER(iwp) ::  iclp      !< Left boundary index for anterpolation along x
-       INTEGER(iwp) ::  icrm      !< Right boundary index for anterpolation along x
        INTEGER(iwp) ::  j         !< Running index y-direction - fine-grid
+       INTEGER(iwp) ::  jcna      !< North boundary index for anterpolation along y
+       INTEGER(iwp) ::  jcsa      !< South boundary index for anterpolation along y
        INTEGER(iwp) ::  jj        !< Running index y-direction - coarse grid
-       INTEGER(iwp) ::  jcnm      !< North boundary index for anterpolation along y
-       INTEGER(iwp) ::  jcsp      !< South boundary index for anterpolation along y
        INTEGER(iwp) ::  k         !< Running index z-direction - fine-grid     
+       INTEGER(iwp) ::  kcb = 0   !< Bottom boundary index for anterpolation along z
        INTEGER(iwp) ::  kk        !< Running index z-direction - coarse grid
-       INTEGER(iwp) ::  kcb = 0   !< Bottom boundary index for anterpolation along z
        INTEGER(iwp) ::  var_flag  !< bit number used to flag topography on respective grid
 
@@ -5686,8 +6185,8 @@
        INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
        INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-
-       INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
 
        REAL(wp) ::  cellsum   !< sum of respective child cells belonging to parent cell 
@@ -5698,12 +6197,5 @@
   
 !
-!--    Initialize the index bounds for anterpolation 
-       iclp = icl 
-       icrm = icr 
-       jcsp = jcs 
-       jcnm = jcn 
-       kcb  = 0
-!
-!--    Define the index bounds iclp, icrm, jcsp and jcnm.
+!--    Define the index bounds icla, icra, jcsa and jcna.
 !--    Note that kcb is simply zero and kct enters here as a parameter and it is
 !--    determined in pmci_init_anterp_tophat.
@@ -5714,40 +6206,36 @@
 !--    child domain, leading to increased velocity variances. A more 
 !--    comprehensive explanation for this is still pending.
-       IF ( nesting_mode == 'vertical' )  THEN
-          IF ( bc_dirichlet_l )  THEN
-             iclp = icl + nhll
-          ENDIF
-          IF ( bc_dirichlet_r ) THEN
-             icrm = icr - nhlr
-          ENDIF
-          IF ( bc_dirichlet_s )  THEN
-             jcsp = jcs + nhls
-          ENDIF
-          IF ( bc_dirichlet_n )  THEN
-             jcnm = jcn - nhln
-          ENDIF
-       ELSE
+       icla = coarse_bound_anterp(1)
+       icra = coarse_bound_anterp(2) 
+       jcsa = coarse_bound_anterp(3)
+       jcna = coarse_bound_anterp(4)
+       kcb  = 0
+       IF ( nesting_mode /= 'vertical' )  THEN
           IF ( bc_dirichlet_l )  THEN
              IF ( var == 'u' )  THEN
-                iclp = icl + nhll + 1 + 1
+                icla = coarse_bound_anterp(1) + 2
              ELSE
-                iclp = icl + nhll + 1
+                icla = coarse_bound_anterp(1) + 1
              ENDIF
           ENDIF
           IF ( bc_dirichlet_r )  THEN
-             icrm = icr - nhlr - 1
+             icra = coarse_bound_anterp(2) - 1
           ENDIF
 
           IF ( bc_dirichlet_s )  THEN
              IF ( var == 'v' )  THEN
-                jcsp = jcs + nhls + 1 + 1
+                jcsa = coarse_bound_anterp(3) + 2
              ELSE
-                jcsp = jcs + nhls + 1
+                jcsa = coarse_bound_anterp(3) + 1
              ENDIF
           ENDIF
           IF ( bc_dirichlet_n )  THEN
-             jcnm = jcn - nhln - 1
+             jcna = coarse_bound_anterp(4) - 1
           ENDIF
        ENDIF
+
+!       write(9,"('pmci_anterp_tophat: ',4(e12.5,2x))")   &
+!            cg%coord_x(icla), cg%coord_y(jcsa),  cg%coord_x(icra), cg%coord_y(jcna)  
+!       flush(9)
 !
 !--    Set masking bit for topography flags 
@@ -5761,15 +6249,13 @@
           var_flag = 0
        ENDIF  
-
 !
 !--    Note that ii, jj, and kk are coarse-grid indices and i,j, and k 
 !--    are fine-grid indices.
-       DO  ii = iclp, icrm
-          DO  jj = jcsp, jcnm
+       DO  ii = icla, icra
+          DO  jj = jcsa, jcna
 !
 !--          For simplicity anterpolate within buildings and under elevated
 !--          terrain too
-             DO  kk = kcb, kct - 1
-
+             DO  kk = kcb, kct - 1                
                 cellsum = 0.0_wp
                 DO  i = ifl(ii), ifu(ii)
@@ -5783,5 +6269,7 @@
 !
 !--             Spatial under-relaxation.
-                fra  = frax(ii) * fray(jj) * fraz(kk)
+!--             The relaxation buffer zones are no longer needed with
+!--             the new reversible interpolation algorithm. 23.19.2018.
+!                fra  = frax(ii) * fray(jj) * fraz(kk)                
 !
 !--             In case all child grid points are inside topography, i.e. 
@@ -5791,8 +6279,9 @@
 !--             zero, keep the parent solution at this point. 
                 IF ( ijkfc(kk,jj,ii) /= 0 )  THEN
-                   fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +            &
-                                    fra * cellsum  /                           &
-                                    REAL( ijkfc(kk,jj,ii), KIND=wp )
-                ENDIF  
+!                   fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +         &
+!                        fra * cellsum  /                                    &
+!                        REAL( ijkfc(kk,jj,ii), KIND=wp )
+                   fc(kk,jj,ii) = cellsum / REAL( ijkfc(kk,jj,ii), KIND=wp )
+                ENDIF
 
              ENDDO
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3483)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3484)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! pmci_ensure_nest_mass_conservation is premanently removed
+! 
+! 3473 2018-10-30 20:50:15Z suehring
 ! new module for virtual measurements introduced
 ! 
@@ -517,5 +520,5 @@
     USE pmc_interface,                                                         &
         ONLY:  nested_run, nesting_mode, pmci_boundary_conds, pmci_datatrans,  &
-               pmci_ensure_nest_mass_conservation, pmci_synchronize
+               pmci_synchronize
 
     USE progress_bar,                                                          &
@@ -978,13 +981,4 @@
 !--          Set boundary conditions again after interpolation and anterpolation.
              CALL pmci_boundary_conds
-!
-!--          Correct the w top-BC in nest domains to ensure mass conservation.
-!--          This action must never be done for the root domain. Vertical 
-!--          Commented out April 18, 2018 as seemingly unnecessary. 
-!--          Will later be completely removed.
-!--             IF ( child_domain )  THEN
-!--                CALL pmci_ensure_nest_mass_conservation
-!--             ENDIF
-
 
              CALL cpu_log( log_point(60), 'nesting', 'stop' )
